package com.perforce.hws.core.p4base;

import java.util.List;

/**
 * Used to flag unexpected results from method calls.
 */
public class P4ResultsException extends RuntimeException {

    private List<ResultMap> results;

    public P4ResultsException(List<ResultMap> results) {
        this.results = results;
    }

    public P4ResultsException(Throwable cause, List<ResultMap> results) {
        super(cause);
        this.results = results;
    }

    public P4ResultsException(String message, List<ResultMap> results) {
        super(message);
        this.results = results;
    }

    public P4ResultsException(String message, Throwable cause, List<ResultMap> results) {
        super(message, cause);
        this.results = results;
    }

    public P4ResultsException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace, List<ResultMap> results) {
        super(message, cause, enableSuppression, writableStackTrace);
        this.results = results;
    }

    public List<ResultMap> getResults() {
        return results;
    }

    public void setResults(List<ResultMap> results) {
        this.results = results;
    }
}
