package com.perforce.hws.core.p4base;

import com.perforce.p4java.server.IServer;

import java.util.List;
import java.util.Map;
import java.util.function.Supplier;

import static java.util.stream.Collectors.joining;

/**
 * P4Java (as of 2015.2) does not support the "server" spec commands, so we
 * use these methods as a way of working around this limitation.
 */
public interface ServerSpecMethods extends P4Methods {

    default List<? extends Map<String,Object>> saveServerSpec(Supplier<IServer> serverSupplier,
                                                              Map<String, Object> input) {

        // Recommended workaround from mruan
        // TODO: we likely need escaping, but for server specs... not sure
        String specStr =
                input.entrySet().stream()
                        .filter(e -> !e.getKey().equals("specFormatted"))
                        .map(e -> e.getKey() + ": " + e.getValue())
                        .collect(joining("\n\n"));

        return execInputString(serverSupplier, specStr, "server", "-i");
    }
}